float4x4 World;
float4x4 View;
float4x4 Projection;

// TODO: add additional effect parameters here.

//// This is the DX10/11 syntax for texture sampler declarations
//// There is no need to mention the texture here - see pixel shader
//SamplerState samLinear
//{
//    Filter = MIN_MAG_MIP_LINEAR;
//    AddressU = Wrap;
//    AddressV = Wrap;
//};

struct VertexShaderInput
{
    float4 Position : POSITION;

    // TODO: add input channels such as texture
    // coordinates and vertex colors here.
};

struct VertexShaderOutput
{
    float4 Position : SV_POSITION;

    // TODO: add vertex shader outputs such as colors and texture
    // coordinates here. These values will automatically be interpolated
    // over the triangle, and provided as input to your pixel shader.
};

VertexShaderOutput VertexShaderFunction(VertexShaderInput input)
{
    VertexShaderOutput output;
    float4 worldPosition = mul(input.Position, World);
    float4 viewPosition = mul(worldPosition, View);
    output.Position = mul(viewPosition, Projection);

    // TODO: add your vertex shader code here.

    return output;
}

float4 PixelShaderFunction(VertexShaderOutput input) : SV_TARGET
{
    // TODO: add your pixel shader code here.

    return float4(1, 0, 0, 1);

	//// Assuming a texture2D <mytexture>, as an effect parameter
	//// this is (one of) the DX10/11 way(s) of sampling
	//return <mytexture>.Sample(samLinear, <texture coordinates>);
}

technique11 Technique1
{
    pass Pass1
    {
        // TODO: set renderstates here.

        SetVertexShader( CompileShader( vs_5_0, VertexShaderFunction() ) );
		SetHullShader( NULL );
		SetDomainShader( NULL );
		SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_5_0, PixelShaderFunction() ) );
    }
}
